/*Impulszhler Zhler mit zwei getrennten Zhleingngen
  Anwendung: Impulszhlung von Geiger-Mller-Zhlrohren
  Impulszhlung durch BEttigung der Tasten :
 F9 : Zhlt Impulse an der Probe                  (Kanal1)
F10 : Zhlt Impulse zur Kompensation z.b. Backgr. (Kanal2)
Ergebnisse werden einmal pro Minute auf Dateien geschrieben:
FF2.DAT : Zeit (Sekunden) und kumulierte Zhlerstnde
FF2_IPS : Zeit (Sekunden) und berechnete Impulsrate
FF2_ERR : Zeit (Sekunden) und berechnete 1Sigma (Messfehler der Impulsrate)
*/

#include <stdio.h>
#include <dos.h>
#include <math.h>
#include <ctype.h>

void save(); /* speichert die Daten in drei Dateien */

long *tm,zeit_start1=0,zeit_start2,zeit_end=0;
FILE *fp1;
int taste,t1,t2;
long z1=0,z2=0,z3=0;
float spanne=0.001,spanne2,h1;


main(){


t1=17152;  /* tastaturcode fr F9 */
t2=17408;   /* tastaturcode fr F10*/


system("cls");
printf("Tastenzhler F9 F10  mit Fehlerrechnung (Statistik)\n");
printf("Erzeugt einmal pro Minute: ZZ2.DAT; ZZ2_IPS.TXT; ZZ2_ERR.TXT\n");
/* ZZ2.DAT  alle Zhlergebnisse */
/* ZZ2_IPS  die berechnete Impulsrate IPS=Impulse Pro Sekunde */
/* ZZ2_ERR  die EIN-SIGMA-Grenze (Error-Level) */

printf("Starten/Beenden mit (RETURN) oder (ESC)  \n");


lblwarte:
while(!bioskey(1)); /* warten auf Tastendruck */
taste=bioskey(0);  /*bettigte Taste holen */
/*printf("Tastencode=%d",taste);*/

if(taste==283 )goto ende1;  /* Taste "ESC" wurde bettigt --> Programm Zhlung beenden */
if(taste!=15104 && taste!= 7181)goto lblwarte;  /* auf Taste F1 warten */

fp1=fopen("zz2.dat","w");fclose(fp1);/*lschen der datei*/
fp1=fopen("zz2_ips.txt","w");fclose(fp1);/*lschen der datei*/
fp1=fopen("zz2_err.txt","w");fclose(fp1);/*lschen der datei*/

time(&zeit_start1);
time(&zeit_start2);
time(&zeit_end);
spanne=zeit_end-zeit_start1+0.1;

gotoxy(1,5);printf("  ZEIT [s]      IMPULSE +-1SIGMA       IPS +-1Sigma");
gotoxy(1,6);printf(" %7.0f           [1]                    [1/s]            ",spanne);
gotoxy(1,7);printf("------------------------------------------------------");
gotoxy(1,10);printf("-----------------------------------------------------");
lbltaste:
gotoxy(1,6);printf(" %7.0f ",spanne);
h1=(float)sqrt((double)z1);
gotoxy(1,8);
printf("F9....:    %7ld   +-%3.0f            %8.4f +-%4.2f",z1,h1,z1/spanne,h1/spanne);
h1=(float)sqrt((double)z2);
gotoxy(1,9);
printf("F10...:    %7ld   +-%3.0f            %8.4f +-%4.2f",z2,h1,z2/spanne,h1/spanne);
z3=z1-z2;
h1=(float)sqrt((double)(z1+z2));
gotoxy(1,11);
printf("F9-F10:    %7ld   +-%3.0f            %8.4f +-%4.2f",z3,h1,z3/spanne,h1/spanne);


while(!bioskey(1)); /* warten auf Tastendruck */
taste=bioskey(0);  /*bettigte Taste holen */

if(taste==t1){
z1++;  /* Taste "F9" wurde bettigt --> Zhler1 hochzhlen */
             }

if(taste==t2){
z2++;  /* Taste "F10" wurde bettigt --> Zhler2 hochzhlen */
             }

time(&zeit_end);
spanne=zeit_end-zeit_start1;
spanne2=zeit_end-zeit_start2;


if(spanne2>=60){
time(&zeit_start2);
zeit_start2=zeit_start2-spanne2+60;
save();   /* speichern der daten */
              }

if(taste==283 || taste== 7181)goto ende1;  /* Taste "ESC" oder (RETURN) wurde bettigt --> Zhlung beenden */

goto lbltaste;


ende1:

save(); /* speichern der Daten */

}

void save()
{
fp1=fopen("zz2.DAT","a");
fprintf(fp1,"\n%6.0f %6ld %6ld",spanne,z1,z2);
fclose(fp1);
fp1=fopen("zz2_ips.TXT","a"); /* Impulsrate */
fprintf(fp1,"%6.0f ;%8.5f \n",spanne,(float)z3/spanne);
fclose(fp1);
fp1=fopen("zz2_err.TXT","a"); /* Zuflliger Fehler der Impulsrate */
fprintf(fp1,"%6.0f ;%8.5f \n",spanne,(float)h1/spanne);
fclose(fp1);
}